      PROGRAM YSMA956
       IMPLICIT NONE
       DOUBLE PRECISION A(20,4)
       DOUBLE PRECISION VFRAC,PWT,MATRD,PARTD,PSPA,PIE,PRAD,PIRON20,
     &                  SSOL20,CR,MO,TI,K,GRAS20,GSIZE,CTEMP,KTEMP,MODD,
     &                  SMOD,BUGV,EXPT,QES,RGAS,DIFF,DDIF,LOGN,SRATE,
     &                  LOGD,DDENS,AVAC,LOGT,SPT,PARTS,PIRON,SSOL,
     &                  GRAS,RYST,URST,KK
       PARAMETER(PIE=3.141592654D+00) 
       INTEGER I,IJI,IROW1,ICOL
C
C
       OPEN(3, FILE='YIELD')
C
C  Note: DATA.DAT and ARRAY.DAT are used for testing purposes only
C
c       OPEN(10,FILE='DAT.DAT')
C       OPEN(11,FILE='ARRAY.DAT')
C       
       IROW1=13
       ICOL=4
C
C This reads data from DATA.DAT
C
	READ(*,*) MO,CR,TI,PRAD,GSIZE,
     &           DDENS,RGAS,AVAC,DDIF,QES,
     &           SMOD,BUGV,MATRD,PARTD,
     &           PWT,SRATE
	K = RGAS/6.023D23

C
C  This DO loop reads the data in the array file, A(I,J).
C
       DO 100 I=1,IROW1
        READ(*,*)A(I,1),A(I,2),A(I,3),A(I,4)
100    CONTINUE
       CLOSE(10)
       CLOSE(11)
C
C  Volume fraction of particle from weight percent  
C
       VFRAC = PWT*MATRD/PARTD
C
C  Particle spacing
C
       PSPA = SQRT(2.0*PIE/3.0)*SQRT((PRAD**2.0D+00)/VFRAC)
C
C  Strength of pure iron at room temperature
C
       PIRON20 = 215.76D+00
C
C  Solid solution strengthening at room temperature.
C
       SSOL20 = 8.5D+00*CR + 58.0D+00*MO - 107.0D+00*TI
C
C  Grain boundary strengthening at room temperature
C
       KK = 15.9D+00*(1.0/1000.0)**0.5
       GRAS20 = KK*(GSIZE**(-0.5))
C
       I=1
       DO 1 IJI = 3,15
         KTEMP = 100.0*IJI
         CTEMP = KTEMP-273.15
C
C  Particle strengthening
C
         MODD = (SMOD*BUGV)/PSPA
         EXPT = QES/(RGAS*KTEMP)
         DIFF = DDIF*DEXP(-EXPT)
         LOGN = SRATE*K*KTEMP*PRAD**2.0D+00
         LOGD = 4.0D+00*PIE*DDENS*(BUGV**2.0D0)*AVAC*SMOD*PSPA*DIFF
         LOGT = 0.12D+00*DLOG10(LOGN/LOGD)
         SPT = 9.8D+00*0.51D+00 + LOGT 
	 MODD = MODD/1.0D+06
         PARTS = MODD*SPT/9.8D+00
C
         PIRON = PIRON20*A(I,2)
         SSOL = SSOL20*A(I,3)
         GRAS = GRAS20*A(I,4)
C
C  Recrystallized yield strength
C
         RYST = PIRON + SSOL + PARTS
C
C  Unrecrystallized yield strength
C
         URST = RYST + GRAS
C
C  Results are in MPa
C
         WRITE(*,2)CTEMP,KTEMP,PIRON,SSOL,PARTS,GRAS,RYST,URST
         WRITE(3,2)CTEMP,KTEMP,PIRON,SSOL,PARTS,GRAS,RYST,URST
C
2        FORMAT(2F8.0,6F10.0,2E14.7)
         I = I + 1
1      CONTINUE
       STOP
       END

